unit Unit5;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  System.TypInfo, System.Rtti, FMX.Types, FMX.Controls, FMX.Forms,
  FMX.Controls.Presentation, FMX.StdCtrls, FMX.Memo.Types, FMX.ScrollBox,
  FMX.Memo;

type
  IMyTrxService = interface(IInvokable)
  ['{1D54A273-58B0-4B7A-95AB-44DDAB93411C}']
    function EchoString(Value1,
                        Value2,
                        Value3,
                        Value4,
                        Value5,
                        Value6: string;
                        Value7: Integer;
                        Value8: Integer;
                        Value9: Integer;
                        Value10: Integer): string;
  end;

  TForm5 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    procedure GetIntf(TypeInfo: PTypeInfo; out Intf);
  public
  end;

var
  Form5: TForm5;

implementation

{$R *.fmx}

procedure TForm5.Button1Click(Sender: TObject);
var
  Service: IMyTrxService;
begin
  GetIntf(TypeInfo(IMyTrxService), Service);
  Memo1.Lines.Add(Service.EchoString('1','2','3','4','5','6',119,119,119,119));
end;

procedure TForm5.GetIntf(TypeInfo: PTypeInfo; out Intf);
var
  V: TVirtualInterface;
begin
  V := TVirtualInterface.Create(TypeInfo);
  V.OnInvoke := procedure(Method: TRttiMethod; const Args: TArray<TValue>; out Result: TValue)
    begin
      Result :=
        Args[1].AsString+'-'+
        Args[2].AsString+'-'+
        Args[3].AsString+'-'+
        Args[4].AsString+'-'+
        Args[5].AsString+'-'+
        Args[6].AsString+'-'+
        IntToStr(Args[7].AsInteger)+'-'+
        IntToStr(Args[8].AsInteger)+'-'+
        IntToStr(Args[9].AsInteger)+'-'+
        IntToStr(Args[10].AsInteger);
    end;
  if V.QueryInterface(GetTypeData(TypeInfo).Guid, Intf) <> S_OK then
    raise Exception.Create('Could not query interface');
end;

end.
